From 38c718f8cd2c079219e5341e72e99664f150a581 Mon Sep 17 00:00:00 2001
From: Bertrand Drouvot <bertranddrouvot.pg@gmail.com>
Date: Thu, 6 Mar 2025 09:49:49 +0000
Subject: [PATCH v16 1/2] Add an extra check in
 pgstat_backend_have_pending_cb()

There is no reason for pgstat_backend_have_pending_cb() to not check
for pgstat_tracks_backend_bktype(). It could wrongly reports true should
PendingBackendStats not be full of zeroes.
---
 src/backend/utils/activity/pgstat_backend.c | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)
 100.0% src/backend/utils/activity/

diff --git a/src/backend/utils/activity/pgstat_backend.c b/src/backend/utils/activity/pgstat_backend.c
index a9343b7b59e..1d94d3176b2 100644
--- a/src/backend/utils/activity/pgstat_backend.c
+++ b/src/backend/utils/activity/pgstat_backend.c
@@ -222,8 +222,11 @@ pgstat_flush_backend(bool nowait, bits32 flags)
 bool
 pgstat_backend_have_pending_cb(void)
 {
-	return (!pg_memory_is_all_zeros(&PendingBackendStats,
-									sizeof(struct PgStat_BackendPending)));
+	if (!pgstat_tracks_backend_bktype(MyBackendType))
+		return false;
+	else
+		return (!pg_memory_is_all_zeros(&PendingBackendStats,
+										sizeof(struct PgStat_BackendPending)));
 }
 
 /*
-- 
2.34.1

